Index: thirdparty/blosc/LICENSES/BITSHUFFLE.txt
===================================================================
--- thirdparty/blosc/LICENSES/BITSHUFFLE.txt	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
+++ thirdparty/blosc/LICENSES/BITSHUFFLE.txt	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
@@ -0,0 +1,21 @@
+Bitshuffle - Filter for improving compression of typed binary data.
+
+Copyright (c) 2014 Kiyoshi Masui (kiyo@physics.ubc.ca)
+
+Permission is hereby granted, free of charge, to any person obtaining a copy
+of this software and associated documentation files (the "Software"), to deal
+in the Software without restriction, including without limitation the rights
+to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the Software is
+furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in
+all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+THE SOFTWARE.
Index: thirdparty/blosc/LICENSES/BLOSC.txt
===================================================================
--- thirdparty/blosc/LICENSES/BLOSC.txt	(revision 00587dc5492d37549f9181cc536aef5fcd190667)
+++ thirdparty/blosc/LICENSES/BLOSC.txt	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
@@ -1,6 +1,5 @@
 Blosc - A blocking, shuffling and lossless compression library
 
-Copyright (C) 2009-2012 Francesc Alted <faltet@gmail.com>
-Copyright (C) 2013      Francesc Alted <faltet@gmail.com>
+Copyright (C) 2009-2016 Francesc Alted <francesc@blosc.org>
 
 Permission is hereby granted, free of charge, to any person obtaining a copy
@@ -21,3 +20,2 @@
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
-
Index: thirdparty/blosc/LICENSES/LZ4.txt
===================================================================
--- thirdparty/blosc/LICENSES/LZ4.txt	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
+++ thirdparty/blosc/LICENSES/LZ4.txt	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
@@ -0,0 +1,32 @@
+LZ4 - Fast LZ compression algorithm
+
+Copyright (C) 2011-2014, Yann Collet.
+BSD 2-Clause License (http://www.opensource.org/licenses/bsd-license.php)
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions are
+met:
+
+    * Redistributions of source code must retain the above copyright
+notice, this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above
+copyright notice, this list of conditions and the following disclaimer
+in the documentation and/or other materials provided with the
+distribution.
+
+THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+You can contact the author at :
+- LZ4 homepage : http://fastcompression.blogspot.com/p/lz4.html
+- LZ4 source repository : http://code.google.com/p/lz4/
+
Index: thirdparty/blosc/LICENSES/SNAPPY.txt
===================================================================
--- thirdparty/blosc/LICENSES/SNAPPY.txt	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
+++ thirdparty/blosc/LICENSES/SNAPPY.txt	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
@@ -0,0 +1,28 @@
+Copyright 2011, Google Inc.
+All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions are
+met:
+
+    * Redistributions of source code must retain the above copyright
+notice, this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above
+copyright notice, this list of conditions and the following disclaimer
+in the documentation and/or other materials provided with the
+distribution.
+    * Neither the name of Google Inc. nor the names of its
+contributors may be used to endorse or promote products derived from
+this software without specific prior written permission.
+
+THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
Index: thirdparty/blosc/LICENSES/STDINT.txt
===================================================================
--- thirdparty/blosc/LICENSES/STDINT.txt	(revision 00587dc5492d37549f9181cc536aef5fcd190667)
+++ thirdparty/blosc/LICENSES/STDINT.txt	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
@@ -1,3 +1,6 @@
-Copyright (c) 2006-2008 Alexander Chemeris
+ISO C9x  compliant stdint.h for Microsoft Visual Studio
+Based on ISO/IEC 9899:TC2 Committee draft (May 6, 2005) WG14/N1124
+
+ Copyright (c) 2006-2013 Alexander Chemeris
 
 Redistribution and use in source and binary forms, with or without
@@ -11,6 +14,7 @@
      documentation and/or other materials provided with the distribution.
 
-  3. The name of the author may be used to endorse or promote products
-     derived from this software without specific prior written permission.
+  3. Neither the name of the product nor the names of its contributors may
+     be used to endorse or promote products derived from this software
+     without specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
Index: thirdparty/blosc/LICENSES/ZLIB.txt
===================================================================
--- thirdparty/blosc/LICENSES/ZLIB.txt	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
+++ thirdparty/blosc/LICENSES/ZLIB.txt	(revision 981e22cfb30050eb24689e86ae83ab31bd8f7926)
@@ -0,0 +1,22 @@
+Copyright notice:
+
+ (C) 1995-2013 Jean-loup Gailly and Mark Adler
+
+  This software is provided 'as-is', without any express or implied
+  warranty.  In no event will the authors be held liable for any damages
+  arising from the use of this software.
+
+  Permission is granted to anyone to use this software for any purpose,
+  including commercial applications, and to alter it and redistribute it
+  freely, subject to the following restrictions:
+
+  1. The origin of this software must not be misrepresented; you must not
+     claim that you wrote the original software. If you use this software
+     in a product, an acknowledgment in the product documentation would be
+     appreciated but is not required.
+  2. Altered source versions must be plainly marked as such, and must not be
+     misrepresented as being the original software.
+  3. This notice may not be removed or altered from any source distribution.
+
+  Jean-loup Gailly        Mark Adler
+  jloup@gzip.org          madler@alumni.caltech.edu